﻿local copyCache = {}
local function eventHandler(self, event, ...)
  if (event=="VARIABLES_LOADED") then
  	BarCopyMainFrame:SetPoint("BOTTOMLEFT","UIParent", "BOTTOMLEFT", BarCopySettings.dispx, BarCopySettings.dispy)
  end
end

function BarCopy_OnLoad(self)
	local version = GetAddOnMetadata("BarCopy", "Version")
	BarCopy_SetVariables()
	--One of them allows BarCopy to be closed with the Escape key
	tinsert(UISpecialFrames, "BarCopyMainFrame")
	UIPanelWindows["BarCopyMainFrame"] = nil

	self:SetScript("OnEvent", eventHandler)
	self:RegisterEvent("VARIABLES_LOADED")

	SlashCmdList["BarCopy"] = function(msg)
		BarCopy_SlashCommand(msg)
	end
	SLASH_BarCopy1 = "/barcopy"

	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00BarCopy v"..version.." loaded")
	end
	UIErrorsFrame:AddMessage("BarCopy v"..version.." AddOn loaded", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME)
end

function BarCopy_SetVariables()
	if(not BarCopySettings) then
		BarCopySettings = {}
		BarCopySettings.dispx = GetScreenWidth()/2 - 200
		BarCopySettings.dispy = GetScreenHeight()/2 - 200
	end
end

function BarCopy_SlashCommand(msg)
  if(msg) then
	local command = strlower(msg)
	if(command == "show") then
		BarCopyMainFrame:Show()
	else
		if BarCopyMainFrame:IsShown() then
			BarCopyMainFrame:Hide()
		else
			BarCopyMainFrame:Show()
		end
	end
  end
end

function BarCopyConfigFrame_OnLoad(panel)
end

function BarCopy_SavePosition(panel)
	BarCopySettings.dispx = panel:GetLeft()
	BarCopySettings.dispy = panel:GetBottom()
end

function BarCopy_Paste(bar)
	for i = 1, 12 do
		local action = (bar-1)*12 + i
		ClearCursor()
		PickupAction(action)
		ClearCursor()
		if copyCache[i][1] == "spell" then
			PickupSpell(copyCache[i][2])
			if not GetCursorInfo() then
				local name = GetSpellInfo(copyCache[i][2])
				PickupSpellBookItem(name)
				--print("No item")
			end
			--print("Spell:", copyCache[i][2])
		elseif copyCache[i][1] == "item" then
			PickupItem(copyCache[i][2])
			--print("Item:", copyCache[i][2])
		elseif copyCache[i][1] == "macro" then
			PickupMacro(copyCache[i][2])
			--print("Macro:", copyCache[i][2])
		elseif copyCache[i][1] == "flyout" then
			PickupFlyout(copyCache[i][2])
			--print("Flyout:", copyCache[i][2])
		elseif copyCache[i][1] == "companion" then
			local position
			for a = 1, GetNumCompanions(copyCache[i][3]) do
				creatureID, creatureName, spellID = GetCompanionInfo(copyCache[i][3], a)
				if spellID == copyCache[i][2] then
					position = a
				end
			end
			PickupCompanion(copyCache[i][3],position)
			--print("Companion:", copyCache[i][3], copyCache[i][2])
		elseif copyCache[i][1] == "equipmentset" then
			PickupEquipmentSet(copyCache[i][2])
			--print("Equipmentset:", copyCache[i][2])
		end
		if not _G["BarCopyMainFrameIndicator"..i]:GetChecked() then
			PlaceAction(action)
		end
		ClearCursor()
	end
end

function BarCopy_Copy(bar)
	copyCache[i] = {}
	for i = 1, 12 do
		local type, id, subtype, spellId = GetActionInfo((bar-1)*12+i)
		copyCache[i] = {type, id, subtype, spellId}
		--print(i, ": Type:" , type, "subtype:", subtype, "id:", id, "spellId:", spellId)
		local texture = GetActionTexture((bar-1)*12+i)
		local button = _G["BarCopyMainFrameIndicator"..i]
		button:SetNormalTexture(texture)
	end
end

function PickupFlyout(id)
	local iii=1
	while true do
		local sbtype, sbid = GetSpellBookItemInfo(iii, "spell")
		if sbtype=="FLYOUT" and sbid==id then
			PickupSpellBookItem(iii, "spell")
			return true
		elseif sbtype==nil and sbid==nil then
			return false
		end
		iii = iii+1
	end
end

function BarCopyButton_OnClick(button)
	local thisID = button:GetID()
	local what
	if thisID > 20 then
		thisID = thisID - 20
		BarCopy_Paste(thisID)
	else
		thisID = thisID - 10
		BarCopy_Copy(thisID)
	end
end